﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ComboError
{
	public partial class Form1 : Form
	{
		public delegate void NotificationEventHandler(object Sender, ComboError.Events.NotificationEventArgs e);
		public event NotificationEventHandler OnMyNotification;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.OnMyNotification += new NotificationEventHandler(OnNotification);

			this.ultraCombo1.DataSource = Get1RowSource();
			this.ultraCombo1.DisplayMember = "Anzeige";
			this.ultraCombo1.ValueMember = "Kuerzel";
			this.ultraCombo1.Value = "k";

			this.ultraCombo2.DataSource = Get2RowSource();
			this.ultraCombo1.DisplayMember = "Anzeige";
			this.ultraCombo1.ValueMember = "Kuerzel";
			this.ultraCombo1.Value = "120";

		}

		void OnNotification(object sender, ComboError.Events.NotificationEventArgs e)
		{
			switch (e.EventState)
			{
				case ComboError.Events.NotificationEventStates.Completed:
					this.ultraStatusBar1.Panels[0].Text = string.Empty;
					break;
				case ComboError.Events.NotificationEventStates.Running:
					this.ultraStatusBar1.Panels[0].Text = DateTime.Now.ToLongTimeString();
					break;
				case ComboError.Events.NotificationEventStates.Started:
					this.ultraStatusBar1.Panels[0].Text = e.Parameter;
					break;
			}

			Application.DoEvents();
		}

		public void Recalc()
		{
			this.ultraCombo2.DataSource = Get2RowSource();
			this.ultraCombo1.DisplayMember = "Anzeige";
			this.ultraCombo1.ValueMember = "Kuerzel";
			this.ultraCombo1.Value = "120";
		}

		private DataTable Get1RowSource()
		{
			DataRow newRow = null;
			DataTable dt = new DataTable();

			dt.Columns.Add(new DataColumn("Kuerzel", typeof(String)));
			dt.Columns.Add(new DataColumn("Anzeige", typeof(String)));

			for (int i = 0; i < 100; i++)
			{
				newRow = dt.Rows.Add(i.ToString(), "Radiergummi" + i.ToString());
			}
			return dt;
		}

		private DataTable Get2RowSource()
		{
			ComboError.Events.NotificationEventArgs e = new ComboError.Events.NotificationEventArgs(null, 
				"Patrick",
				ComboError.Events.NotificationEventStates.Started,
				ComboError.Events.NotificationEventTypes.Recalc);

			if (OnMyNotification != null)
				OnMyNotification(this, e);

			DataRow newRow = null;
			DataTable dt = new DataTable();

			dt.Columns.Add(new DataColumn("Kuerzel", typeof(String)));
			dt.Columns.Add(new DataColumn("Anzeige", typeof(String)));

			for (int i = 0; i < 10000; i++)
			{
				e = new ComboError.Events.NotificationEventArgs(null,
				"Patrick", 
				ComboError.Events.NotificationEventStates.Running,
				ComboError.Events.NotificationEventTypes.Recalc);

				if (OnMyNotification != null)
					OnMyNotification(this, e);

				newRow = dt.Rows.Add(i.ToString(), "Radiergummi" + i.ToString());
			}

			e = new ComboError.Events.NotificationEventArgs(null,
				"Patrick",
				ComboError.Events.NotificationEventStates.Completed,
				ComboError.Events.NotificationEventTypes.Recalc);

			if (OnMyNotification != null)
				OnMyNotification(this, e);

			return dt;
		}

		private void OnValueChanged(object sender, EventArgs e)
		{
			this.Recalc();
		}

	}
}
